;
;	ALTIE VERSION 2
;
*GET	MACRO6
MOVEIT	MACRO	#LOCATION,#LENGTH
	PUSH	BC
	PUSH	HL		;MUST SAVE
	LD	HL,#LOCATION
	LD	B,#LENGTH
LABEL	DEFL	$
	LD	A,(HL)
	LD	(IX),A
	INC	IX
	INC	HL
	DJNZ	LABEL
	POP	HL
	POP	BC
	ENDM
;
;
	ORG	3000H
;
START
	LD	HL,80*5+SCREEN
	LD	DE,80*5+SCREEN+1
	LD	BC,1920
	LD	A,32
	LD	(HL),A
	LDIR			;CLEAR SCREEN IMAGE
	@FLAGS			;Get flags
	LD	A,(IY+4)	;FIND OUT IF WE ARE DOING ANYTHING
	OR	A
	JP	Z,LEAVE		;EXIT IF NOT
	RES	7,A		;Make sure there is no flag on it
	LD	(FILE4),A	;SAVE FILE WE WANT TO OPEN
	@FSPEC	FILENAME,DCB
	JP	NZ,ERRORF
	@FLAGS
	SET	0,(IY+18)	;NO LRL, NO OPEN BIT
	@OPEN	BUFFER,DCB,ULENGTH
	JP	NZ,ERRORF
	@READ	DCB,UREC	;READ THE FIRST RECORD, THIS IS TITLE
	JP	NZ,ERRORF	;THIS IS BAD, THERE HAS TO BE A TITLE
	LD	HL,UREC
	LD	DE,80*6+20+SCREEN	;POINT TO TITLE AREA
	LD	BC,40
	LDIR				;MOVE THE TITLE TO THE SCREEN
	LD	HL,UBUFFER
	LD	DE,UBUFFER+1
	XOR	A
	LD	BC,ULEN
	LD	(HL),A		;SAVE FIRST CHARACTER
	LDIR			;AND BLANK THE REST
;
	LD	IX,UBUFFER	;SET TO START OF BUFFER
	LD	B,26		;THERE ARE 26 RECORDS IN FILE
DX2	@READ	DCB,UREC	;READ IN ONE RECORD
	JP	NZ,ERRORF	;THERE IS A PROBLEM
	MOVEIT	CMDNAME,72	;MOVE THE COMMAND NAME
	MOVEIT	DESC,32		;AND DESCRIPTION
	DJNZ	DX2		;CONTINUE TILL DONE
	@VDCTL	6,OLDSCN	;Save old screen
;
	LD	IX,8*80+SCREEN
	LD	B,0
	LD	HL,UBUFFER	;LOCATE USER BUFFER
JUMP
	MOVEIT	STLNE,3
	LD	A,B		;GET THIS ENTRY NUMBER
	ADD	A,'A';
	LD	(IX),A
	INC	IX		;MOVE LETTER
	LD	A,'.'
	LD	(IX),A		;AND PERIOD
	INC	IX
	LD	A,32
	LD	(IX),A
	INC	IX
	LD	DE,72
	ADD	HL,DE		;ADJUST TO NEXT LOCATION
	MOVEIT	,31		;MOVE THE TEXT
	LD	DE,32
	ADD	HL,DE		;AND ADD IT TO THE USER BUFFER LOC.
	INC	B		;POINT NEXT LETTER
	LD	A,32
	LD	(IX),A
	INC	IX
	LD	A,191
	LD	(IX),A
	INC	IX		;NEXT LOCATION
	LD	(IX),A
	INC	IX
	LD	DE,40
	ADD	IX,DE		;BUMP TO NEXT LINE
	LD	A,B
	CP	26		;DONE??
	JR	Z,DSPLY		;DISPLAY IF SO
	CP	13		;SECOND HALF?
	JR	NZ,JUMP		;GO IF NOT
	LD	IX,80*8+SCREEN+40	;SECOND HALF
	JR	JUMP
DSPLY
	@DSP	28		;Reset to normal GRAPHICS
	@FLAGS
	BIT	7,(IY+4)	;IS IT ON?
	CALL	NZ,ENTER	;ASK FOR <ENTER> KEY IF SO
	LD	A,(WHICH)	;WHICH SCREEN DO WE DISPLAY
	OR	A
	JR	Z,DSPONE	;DISPLAY SCREEN ONE
	@VDCTL	5,OLDSCN
	JR	GETCMD
DSPONE	@VDCTL	5,SCREEN	;MOVE TO THE SCREEN
;
GETCMD
	@VDCTL	3,256*21	;AND POSITION TO START OF FIRST FREE
	@DSPLY	PROMPT
DX3	@KEY			;CHECK FOR KEYBOAR INPUT
	CP	131		;<F3>?
	JP	Z,DOSCMD	;EXECUTE DOS COMMAND IF SO
	CP	129		;<F1>?
	CALL	Z,SWITCH	;SWITCH TO ALTERNATE SCREEN
	JR	Z,DSPLY		;AND DISPLAY IT
	CP	'a'		;IS IT LOWER CASE?
	JP	C,DX4		;DO NOT CONVERT, THIS IS A GOOD THING
	SUB	32		;CONVERT TO UC
DX4	SUB	'A'		;MAKE AN ABSOLUTE NUMBER FROM 0 - 26
	CP	27		;THERE BETTER BE A CARRY FROM THIS ONE!
	JP	NC,ILLCMD	;ILLEGAL COMMAND IF NOT
;
SEARCH	LD	HL,UBUFFER	;START HERE
	LD	DE,ULENGTH	;LENGTH OF BUFFER ENTRY
	OR	A		;IS INDEX ZERO?
	JR	Z,NOSCH		;DON'T SEARCH IT IF SO
	LD	B,A		;OTHERWISE THIS MANY TO DO
CX1	ADD	HL,DE
	DJNZ	CX1
NOSCH	LD	A,(HL)
	CP	32		;SPACE (NOTHING?)
	JR	Z,ILLCMD	;ILLEGAL COMMAND IF SO
EXEC	CP	','		;Is it a comma?
	JR	NZ,EXCCMD	;Execute normal command
	@FLAGS
	SET	7,(IY+4)	;Set flag to indicate wait on return
	INC	HL		;Point to front of command
EXCCMD
	CP	'?'		;Do we pause for parameters?
	JR	NZ,EXEIT	;EXECUTE COMMAND IF NOT
	INC	HL
	PUSH	HL		;Point to first of command & save it
	CALL	DSPIT		;Display the command
	@KEYIN	,70		;Get up to 70 keys of parameters
	POP	HL		;Ready to execute command...
	JP	C,GETCMD	;Don't do it if special character entered
EXEIT
	PUSH	HL		;Must save
	@DSPLY	WAIT		;Display "Wait" message
	POP	HL		;Ready to execute it
	@CMNDI			;EXECUTE COMMAND
;
LEAVE	@DSPLY	BYEMES
	@FLAGS
	LD	(IY+4),0	;Set no ECI
	@EXIT
;
ILLCMD
	@SOUND	0		;Make some noise
	JP	GETCMD		;And get another one
DOSCMD	@DSPLY	DOSCMX
	@KEYIN	INPUT,72
	JP	C,DSPLY			;REDISPLAY IF NOTHING GOOD
	LD	A,B
	OR	A
	JP	Z,GETCMD		;GET COMMAND IF NOTHING ENTERED
	LD	HL,INPUT
	LD	A,(HL)		;GET FIRST CHARACTER
	JP	EXEC		;EXECUTE IT
;
ENTER
	@VDCTL	3,23*256		;MOVE CURSOR TO LAST LINE
	@DSPLY	ENTERPLS		;ENTER PLEASE
ETWAIT	@KEY
	CP	13			;ENTER?
	JR	NZ,ETWAIT
	@FLAGS
	RES	7,(IY+4)	;RESET FLAG FOR IT
	RET				;THEN OUT AS USUAL
;
ERRORF	@FLAGS
	LD	(IY+4),0		;RESET ECI FLAG
	@DSPLY	CANNOT
	@ABORT				;OUT ON ERROR
;
DSPIT
	LD	A,(HL)		;CHECK THIS ONE OUT
	CP	13		;End of title?
	JR	Z,ENDIT
	CP	3
	JR	Z,ENDIT
	@DSP	(HL)
	INC	HL
	JR	DSPIT
ENDIT	RET			;AND OUT
SWITCH	LD	A,(WHICH)
	XOR	0FFH
	LD	(WHICH),A
	XOR	A
	RET			;AND OUT, REDISPLAY MENU
CANNOT	DB	'? Cannot read command file',13
;
ENTERPLS
	DB	'{<ENTER> to return}',15,31,03
;
DOSCMX	DB	8,8,'? ',03
FILENAME
	DB	'COMMAND'
FILE4	DB	' /DAT',13
DCB	DS	32
BUFFER	DS	256
UBUFFER
	DS	72*26		;SPACE FOR COMMANDS
	DS	32*26		;SPACE FOR DESCRIPTIONS
ULEN	EQU	$-UBUFFER
;
UREC
CMDNAME	DS	72
DESC	DS	32
ULENGTH	EQU	$-UREC
PROMPT	DB	31,10,'> ',14,03
WAIT	DB	'One moment please..',3
BYEMES	DB	28,31,'Exit to DOS',13
WHICH	DB	0
STLNE	DB	191,191,32
INPUT	DS	73
SCREEN
	DB	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,128,128,160,158,139,180,128,128,128,170,149,128,128,128
	DB	128,128,130,131,131,131,191,131,131,131,128,131,131,171,151,131
	DB	131,128,191,131,131,131,131,129,128,128,128,128,128,128,128,128
	DB	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,128,184,143,140,140,142,173,144,128,170,149,128,128,128
	DB	128,128,128,128,128,128,191,128,128,128,128,128,128,170,149,128
	DB	128,128,191,143,141,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,142,129,128,128,128,128,128,139,132,138,141,140,140,140
	DB	140,132,128,128,128,128,143,128,128,128,128,140,140,142,141,140
	DB	140,128,143,140,140,140,140,132,128,128,128,128,128,128,128,128
	DB	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128
	DB	128,128,128,128,65,76,84,73,69,32,105,115,32,67,111,112
	DB	121,114,105,103,104,116,32,49,57,56,53,32,68,32,38,32
	DB	68,32,83,121,115,116,101,109,115,46,32,65,108,108,32,114
	DB	105,103,104,116,115,32,114,101,115,101,114,118,101,100,46,32
	DB	84,104,105,115,32,99,111,112,121,128,128,128,128,128,128,128
	DB	128,128,128,128,105,115,32,108,105,99,101,110,115,101,100,32
	DB	111,110,108,121,32,116,111,32,116,104,101,32,111,114,105,103
	DB	105,110,97,108,32,112,117,114,99,104,97,115,101,114,46,32
	DB	80,105,114,97,116,101,115,32,119,105,108,108,32,98,101,32
	DB	112,114,111,115,101,99,117,116,101,100,46,128,128,128,128,128
	DS	1900
OLDSCN	DS	2049
	END	START
